#
# Please see the COPYRIGHT_and_DISCLAIMER file in the top level
# directory of the distribution regarding the provisions under
# which this software is distributed.
#
#package dumpp;    
sub main'dump
{
    print "Port dictionary:\n";
    &dumpVarDict(*PortDict);
    
    print "Reverse port dictionary:\n";
    &dumpAssoc(*PortDictRev);
    
    for (@'Programs)
    {
	&pushState($_);
	&dumpProgram($_);
	&popState;
    }
}

sub main'dumpProgram
{
    local($caller) = caller;

    ($flavor, $isParallel, $returnType) = split(/$;/, $'Programs{$CurrentProgram});

    print "Program '$CurrentProgram': '$flavor' '$isParallel' '$returnType'\n";

    &dumpState;
    return;

    print "Arguments:\n";
    for (@Args)
    {
	($kind, $type, $dim) = &'retrieveVar($_);
	print "   $_: '$kind' '$type' '$dim'\n";
    }

    print "Locals\n";

    for (@Locals)
    {
	($kind, $type, $dim) = &'retrieveVar($_);
	print "   $_: '$kind' '$type' '$dim'\n";
    }

    print "Common blocks:\n";

    while (($name, *array) = each(%'Commons))
    {
	print "    Common block $name:\n";

	for (@array)
	{
	    ($kind, $type, $dim) = &'retrieveVar($_);
	    print "   $_: '$kind' '$type' '$dim'\n";
	}
    }

    print "Raw code:\n";
    print join("\n", @'RawCode, "");

    print "Decl code:\n";
    print join("\n", @'DeclCode, "");

    print "Init code:\n";
    print join("\n", @'InitCode, "");

    print "Cleanup code:\n";
    print join("\n", @'CleanupCode, "");

    print "Body code:\n";
    print join("\n", @'BodyCode, "");
}
    
sub dump_parse_tree
{
    local($t, $indent) = @_;
    local($type, $name);
    local($nkids, $i, $kid);

    print $indent . "$t: ";

    if ($t == 0)
    {
	print "NULL\n";
	return;
    }

    $type = &tree_type($t);
    $name = &name_of_type($type);

    $nkids = &tree_num_kids($t);

    print "$name/$nkids";

#    print " has type $type $name and $nkids kids\n";

    if ($name eq "string")
    {
	$str = &tree_string_value($t);
	print ": \"$str\"\n";
    }
    elsif ($name eq "int")
    {
	$str = &tree_int_value($t);
	print ": $str\n";
    }
    else
    {
	print "\n";
    }

    for ($i = 0; $i < $nkids; $i++)
    {
	$kid = &tree_kid($t, $i);
	&dump_parse_tree($kid, $indent . "  ");
    }
}

1;
