/*
 * Please see the COPYRIGHT_and_DISCLAIMER file in the top level
 * directory of the distribution regarding the provisions under
 * which this software is distributed.
 */


#ifndef _YOKE_INCLUDE_YOKE_C_HDR_H
#define _YOKE_INCLUDE_YOKE_C_HDR_H

#ifndef MAX_PATH_LENGTH
#define MAX_PATH_LENGTH 1024
#endif /* MAX_PATH_LENGTH */

#ifdef s2010
#define YOKE_DONT_INCLUDE_STRING
#define YOKE_DONT_INCLUDE_ANSI
extern int strlen();
extern char *strcpy();
extern char *strncpy();
extern char *strcat();
extern char *strncat();
extern char *strchr();
extern char *strrchr();
extern void *memcpy();
extern void *memset();
#endif /* s2010 */

#ifndef YOKE_DONT_INCLUDE_STRING
#include <string.h>
#endif
#ifdef YOKE_INCLUDE_STRINGS
#include <strings.h>
#endif


#ifndef YOKE_DONT_INCLUDE_ANSI

#include <stddef.h>
#include <stdlib.h>

#else  /* !YOKE_DONT_INCLUDE_ANSI */

#ifndef atof
extern double atof();
#endif

#if defined(s2010)
#define MALLOC_RETURN char
#else
#define MALLOC_RETURN void
#endif
extern void free();
extern MALLOC_RETURN *malloc();
extern MALLOC_RETURN *realloc();


#ifdef symmetry

#include <sys/types.h>

#ifndef NULL
#define NULL ((void *) 0)
#endif

#endif /* symmetry */


#endif /* !YOKE_DONT_INCLUDE_ANSI */


#ifdef YOKE_SYSV
#include <stdio.h>
extern FILE *fdopen();
#endif /* YOKE_SYSV */

/*
 * Some procedure defines to provide for portability...
 */
#ifdef YOKE_STRCHR_TO_INDEX
#define strchr(S,C)     index(S,C)
#define strrchr(S,C)    rindex(S,C)
#endif

#ifdef YOKE_MEMCPY_TO_BCOPY
#define memcpy(Dest,Src,Length)		bcopy(Src,Dest,Length)
#endif

#ifdef YOKE_NO_MEMMOVE
#define memmove(Dest,Src,Length) \
{ \
    char *__Src = ((char *) (Src)); \
    char *__Dest = ((char *) (Dest)); \
    char *__EndSrc = (__Src + (Length)); \
    char *__EndDest = (__Dest + (Length)); \
    if ( (__Src < __Dest) && (__Dest < __EndSrc) ) \
    { \
	/* Overlapping, with __Dest > __Src, so copy from end */ \
	while (__EndSrc > __Src) \
	{ \
	    *(--__EndDest) = *(--__EndSrc); \
	} \
    } \
    else if ( (__Dest < __Src) && (__Src < __EndDest) ) \
    { \
	/* Overlapping, with __Dest < __Src, so copy from beginning */ \
	while (__Src < __EndSrc) \
	{ \
	    *(__Dest++) = *(__Src++); \
	} \
    } \
    else if ( __Src != __Dest ) \
    { \
	/* Non-overlapping (and not the same), so memcpy() can be trusted */ \
	memcpy(Dest,Src,Length); \
    } \
}
#endif /* YOKE_NO_MEMMOVE */

#ifdef YOKE_USE_BZERO
#define ZeroOutMemory(Where,Size)	bzero(Where,Size)
#else
#define ZeroOutMemory(Where,Size)	memset(Where,0,Size)
#endif

#ifdef YOKE_GETWD_TO_GETCWD
extern char *getcwd();
#define getwd(S)	getcwd(S,MAX_PATH_LENGTH)
#else
extern char *getwd();
#endif

#endif /* _YOKE_INCLUDE_YOKE_C_HDR_H */

